Index: Build/MSBUILD_Rebuild_Release_MediaPortal.bat
===================================================================
--- Build/MSBUILD_Rebuild_Release_MediaPortal.bat	(revision 27834)
+++ Build/MSBUILD_Rebuild_Release_MediaPortal.bat	(working copy)
@@ -28,4 +28,4 @@
 
 echo.
 echo Building Installer...
-"%progpath%\NSIS\makensis.exe" /DBUILD_TYPE=%BUILD_TYPE% /DVER_BUILD=%version% "%MediaPortal%\Setup\setup.nsi" >> %log%
+"%progpath%\NSIS\makensis.exe" /DBUILD_TYPE=%BUILD_TYPE% /DVER_REVISION=%version% "%MediaPortal%\Setup\setup.nsi" >> %log%
Index: Build/MSBUILD_Rebuild_Release_TVServer_Client.bat
===================================================================
--- Build/MSBUILD_Rebuild_Release_TVServer_Client.bat	(revision 27834)
+++ Build/MSBUILD_Rebuild_Release_TVServer_Client.bat	(working copy)
@@ -31,4 +31,4 @@
 
 echo.
 echo Building Installer...
-"%progpath%\NSIS\makensis.exe" /DBUILD_TYPE=%BUILD_TYPE% /DVER_BUILD=%version% "%TVLibrary%\Setup\setup.nsi" >> %log%
+"%progpath%\NSIS\makensis.exe" /DBUILD_TYPE=%BUILD_TYPE% /DVER_REVISION=%version% "%TVLibrary%\Setup\setup.nsi" >> %log%
Index: mediaportal/Setup/setup.nsi
===================================================================
--- mediaportal/Setup/setup.nsi	(revision 27834)
+++ mediaportal/Setup/setup.nsi	(working copy)
@@ -136,7 +136,7 @@
 
 !define MUI_HEADERIMAGE
 !define MUI_HEADERIMAGE_BITMAP              "${svn_InstallScripts}\Resources\header.bmp"
-!if ${VER_BUILD} == 0       # it's an official release
+!if ${VER_REVISION} == 0    # it's an official release
   !define MUI_WELCOMEFINISHPAGE_BITMAP      "${svn_InstallScripts}\Resources\wizard-mp.bmp"
 !else                       # it's a svn release
   !define MUI_WELCOMEFINISHPAGE_BITMAP      "${svn_InstallScripts}\Resources\wizard-mp-svn.bmp"
@@ -208,17 +208,17 @@
 #---------------------------------------------------------------------------
 Name          "${PRODUCT_NAME}"
 BrandingText  "${PRODUCT_NAME} ${VERSION} by ${PRODUCT_PUBLISHER}"
-!if ${VER_BUILD} == 0       # it's an official release
+!if ${VER_REVISION} == 0    # it's an official release
   OutFile "${svn_OUT}\package-mediaportal.exe"
 !else                       # it's a svn release
-  OutFile "${svn_OUT}\Setup-MediaPortal-svn-${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD}.exe"
+  OutFile "${svn_OUT}\Setup-MediaPortal-svn-${VER_MAJOR}.${VER_MINOR}.${VER_BUILD}.${VER_REVISION}.exe"
 !endif
 InstallDir ""
 CRCCheck on
 XPStyle on
 RequestExecutionLevel admin
 ShowInstDetails show
-VIProductVersion "${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD}"
+VIProductVersion "${VER_MAJOR}.${VER_MINOR}.${VER_BUILD}.${VER_REVISION}"
 VIAddVersionKey /LANG=${LANG_ENGLISH} ProductName       "${PRODUCT_NAME}"
 VIAddVersionKey /LANG=${LANG_ENGLISH} ProductVersion    "${VERSION}"
 VIAddVersionKey /LANG=${LANG_ENGLISH} CompanyName       "${PRODUCT_PUBLISHER}"
@@ -748,8 +748,8 @@
 
   WriteRegDWORD HKLM "${REG_UNINSTALL}" "VersionMajor"    "${VER_MAJOR}"
   WriteRegDWORD HKLM "${REG_UNINSTALL}" "VersionMinor"    "${VER_MINOR}"
+  WriteRegDWORD HKLM "${REG_UNINSTALL}" "VersionBuild"    "${VER_BUILD}"
   WriteRegDWORD HKLM "${REG_UNINSTALL}" "VersionRevision" "${VER_REVISION}"
-  WriteRegDWORD HKLM "${REG_UNINSTALL}" "VersionBuild"    "${VER_BUILD}"
 
   ; Write Uninstall Information
   WriteRegStr HKLM "${REG_UNINSTALL}" InstallPath        "$MPdir.Base"
Index: Tools/InstallationScripts/DeployToolUnPacker.nsi
===================================================================
--- Tools/InstallationScripts/DeployToolUnPacker.nsi	(revision 27834)
+++ Tools/InstallationScripts/DeployToolUnPacker.nsi	(working copy)
@@ -44,14 +44,14 @@
 !define PRODUCT_PUBLISHER     "Team MediaPortal"
 !define PRODUCT_WEB_SITE      "www.team-mediaportal.com"
 
-; needs to be done before importing MediaPortalCurrentVersion, because there the VER_BUILD will be set, if not already.
-!ifdef VER_BUILD ; means !build_release was used
-  !undef VER_BUILD
+; needs to be done before importing MediaPortalCurrentVersion, because there the VER_REVISION will be set, if not already.
+!ifdef VER_REVISION ; means !build_release was used
+  !undef VER_REVISION
 
   !system 'include-MP-PreBuild.bat'
   !include "version.txt"
   !delfile "version.txt"
-  !if ${VER_BUILD} == 0
+  !if ${VER_REVISION} == 0
     !warning "It seems there was an error, reading the svn revision. 0 will be used."
   !endif
 !endif
@@ -86,10 +86,10 @@
 BrandingText  "${PRODUCT_NAME} ${VERSION} by ${PRODUCT_PUBLISHER}"
 Icon "${svn_DeployTool}\Install.ico"
 !define /date buildTIMESTAMP "%Y-%m-%d-%H-%M"
-!if ${VER_BUILD} == 0
+!if ${VER_REVISION} == 0
   OutFile "${svn_OUT}\MediaPortalSetup_${VERSION}_${buildTIMESTAMP}.exe"
 !else
-  OutFile "${svn_OUT}\MediaPortalSetup_${VERSION}_SVN${VER_BUILD}_${buildTIMESTAMP}.exe"
+  OutFile "${svn_OUT}\MediaPortalSetup_${VERSION}_SVN${VER_REVISION}_${buildTIMESTAMP}.exe"
 !endif
 InstallDir "$TEMP\MediaPortal Installation"
 
@@ -98,7 +98,7 @@
 RequestExecutionLevel admin
 ShowInstDetails show
 AutoCloseWindow true
-VIProductVersion "${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD}"
+VIProductVersion "${VER_MAJOR}.${VER_MINOR}.${VER_BUILD}.${VER_REVISION}"
 VIAddVersionKey ProductName       "${PRODUCT_NAME}"
 VIAddVersionKey ProductVersion    "${VERSION}"
 VIAddVersionKey CompanyName       "${PRODUCT_PUBLISHER}"
Index: Tools/InstallationScripts/include-MP-PreBuild.nsh
===================================================================
--- Tools/InstallationScripts/include-MP-PreBuild.nsh	(revision 27834)
+++ Tools/InstallationScripts/include-MP-PreBuild.nsh	(working copy)
@@ -34,7 +34,7 @@
 ;!define BUILD_Installer
 
 
-!if ${VER_BUILD} != 0
+!if ${VER_REVISION} != 0
 !system '"${svn_DeployVersionSVN}\DeployVersionSVN\bin\Release\DeployVersionSVN.exe" /svn="${svn_MP}"' = 0
 !system '"${svn_DeployVersionSVN}\DeployVersionSVN\bin\Release\DeployVersionSVN.exe" /svn="${svn_TVServer}"' = 0
 !system '"${svn_DeployVersionSVN}\DeployVersionSVN\bin\Release\DeployVersionSVN.exe" /svn="${svn_ROOT}\Common-MP-TVE3"' = 0
Index: Tools/InstallationScripts/include/LoggingMacros.nsh
===================================================================
--- Tools/InstallationScripts/include/LoggingMacros.nsh	(revision 27834)
+++ Tools/InstallationScripts/include/LoggingMacros.nsh	(working copy)
@@ -66,7 +66,7 @@
   ${GetTime} "" "L" $0 $1 $2 $3 $4 $5 $6
   ${LOG_TEXT} "INFO" "${PRODUCT_NAME} ${UNINSTALL_PREFIX}installation"
   ${LOG_TEXT} "INFO" "Logging started: $0.$1.$2 $4:$5:$6"
-  ${LOG_TEXT} "INFO" "${UNINSTALL_PREFIX}installer version: ${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD}"
+  ${LOG_TEXT} "INFO" "${UNINSTALL_PREFIX}installer version: ${VER_MAJOR}.${VER_MINOR}.${VER_BUILD}.${VER_REVISION}"
   ${LOG_TEXT} "INFO" "============================================================================================"
 
 
@@ -95,7 +95,7 @@
   ${GetTime} "" "L" $0 $1 $2 $3 $4 $5 $6
   ${LOG_TEXT} "INFO" "============================================================================================"
   ${LOG_TEXT} "INFO" "Logging stopped: $0.$1.$2 $4:$5:$6"
-  ${LOG_TEXT} "INFO" "${UNINSTALL_PREFIX}installer version: ${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD}"
+  ${LOG_TEXT} "INFO" "${UNINSTALL_PREFIX}installer version: ${VER_MAJOR}.${VER_MINOR}.${VER_BUILD}.${VER_REVISION}"
   ${LOG_TEXT} "INFO" "${PRODUCT_NAME} ${UNINSTALL_PREFIX}installation"
 
   FileClose $LogFile
@@ -107,7 +107,7 @@
   !ifdef INSTALL_LOG_DIR
 
     ${GetTime} "" "L" $0 $1 $2 $3 $4 $5 $6
-    CopyFiles "$TempInstallLog" "${INSTALL_LOG_DIR}\${UNINSTALL_PREFIX}install_${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD}_$2-$1-$0_$4-$5-$6.log"
+    CopyFiles "$TempInstallLog" "${INSTALL_LOG_DIR}\${UNINSTALL_PREFIX}install_${VER_MAJOR}.${VER_MINOR}.${VER_BUILD}.${VER_REVISION}_$2-$1-$0_$4-$5-$6.log"
 
   !else
 
@@ -116,7 +116,7 @@
     !endif
 
     ${GetTime} "" "L" $0 $1 $2 $3 $4 $5 $6
-    CopyFiles "$TempInstallLog" "${COMMON_APPDATA}\log\${UNINSTALL_PREFIX}install_${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD}_$2-$1-$0_$4-$5-$6.log"
+    CopyFiles "$TempInstallLog" "${COMMON_APPDATA}\log\${UNINSTALL_PREFIX}install_${VER_MAJOR}.${VER_MINOR}.${VER_BUILD}.${VER_REVISION}_$2-$1-$0_$4-$5-$6.log"
 
   !endif
 
Index: Tools/InstallationScripts/include/MediaPortalCurrentVersion.nsh
===================================================================
--- Tools/InstallationScripts/include/MediaPortalCurrentVersion.nsh	(revision 27834)
+++ Tools/InstallationScripts/include/MediaPortalCurrentVersion.nsh	(working copy)
@@ -32,9 +32,9 @@
 
 !define VER_MAJOR       1
 !define VER_MINOR       1
-!define VER_REVISION    6
-!ifndef VER_BUILD
-    !define VER_BUILD   0
+!define VER_BUILD       7
+!ifndef VER_REVISION
+    !define VER_REVISION   0
 !endif
 
 !if "${SKRIPT_NAME}" == "MediaPortal Unpacker"
@@ -43,13 +43,13 @@
 !else
 
   !if ${BUILD_TYPE} == "Debug"
-    !define VERSION "${VER_MAJOR}.${VER_MINOR}.${VER_REVISION} >>DEBUG<< build ${VER_BUILD} for TESTING ONLY"
+    !define VERSION "${VER_MAJOR}.${VER_MINOR}.${VER_BUILD} >>DEBUG<< build ${VER_REVISION} for TESTING ONLY"
   !else
 
-    !if ${VER_BUILD} == 0       # it's an official release
-      !define VERSION "1.2.0"
+    !if ${VER_REVISION} == 0       # it's an official release
+      !define VERSION "1.2.0 Beta"
     !else                       # it's a svn release
-      !define VERSION "1.2.0 SVN build ${VER_BUILD} for TESTING ONLY"
+      !define VERSION "1.2.0 SVN build ${VER_REVISION} for TESTING ONLY"
     !endif
 
   !endif
Index: Tools/InstallationScripts/include/MediaPortalMacros.nsh
===================================================================
--- Tools/InstallationScripts/include/MediaPortalMacros.nsh	(revision 27834)
+++ Tools/InstallationScripts/include/MediaPortalMacros.nsh	(working copy)
@@ -374,7 +374,7 @@
     StrCpy $PREVIOUS_VERSION $R0.$R1.$R2.$R3
   ${EndIf}
 
-  ${VersionCompare} ${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD} $PREVIOUS_VERSION $R0
+  ${VersionCompare} ${VER_MAJOR}.${VER_MINOR}.${VER_BUILD}.${VER_REVISION} $PREVIOUS_VERSION $R0
   ${If} $R0 == 0
     StrCpy $PREVIOUS_VERSION_STATE "same"
   ${ElseIf} $R0 == 1
Index: TvEngine3/TVLibrary/Setup/setup.nsi
===================================================================
--- TvEngine3/TVLibrary/Setup/setup.nsi	(revision 27834)
+++ TvEngine3/TVLibrary/Setup/setup.nsi	(working copy)
@@ -204,17 +204,17 @@
 #---------------------------------------------------------------------------
 Name          "${PRODUCT_NAME}"
 BrandingText  "${PRODUCT_NAME} ${VERSION} by ${PRODUCT_PUBLISHER}"
-!if ${VER_BUILD} == 0       # it's an official release
+!if ${VER_REVISION} == 0    # it's an official release
   OutFile "${svn_OUT}\package-tvengine.exe"
 !else                       # it's a svn release
-  OutFile "${svn_OUT}\Setup-TvEngine-svn-${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD}.exe"
+  OutFile "${svn_OUT}\Setup-TvEngine-svn-${VER_MAJOR}.${VER_MINOR}.${VER_BUILD}.${VER_REVISION}.exe"
 !endif
 InstallDir ""
 CRCCheck on
 XPStyle on
 RequestExecutionLevel admin
 ShowInstDetails show
-VIProductVersion "${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD}"
+VIProductVersion "${VER_MAJOR}.${VER_MINOR}.${VER_BUILD}.${VER_REVISION}"
 VIAddVersionKey /LANG=${LANG_ENGLISH} ProductName       "MediaPortal TV Server"
 VIAddVersionKey /LANG=${LANG_ENGLISH} ProductVersion    "${VERSION}"
 VIAddVersionKey /LANG=${LANG_ENGLISH} CompanyName       "${PRODUCT_PUBLISHER}"
@@ -748,8 +748,8 @@
 
   WriteRegDWORD HKLM "${REG_UNINSTALL}" "VersionMajor"    "${VER_MAJOR}"
   WriteRegDWORD HKLM "${REG_UNINSTALL}" "VersionMinor"    "${VER_MINOR}"
+  WriteRegDWORD HKLM "${REG_UNINSTALL}" "VersionBuild"    "${VER_BUILD}"
   WriteRegDWORD HKLM "${REG_UNINSTALL}" "VersionRevision" "${VER_REVISION}"
-  WriteRegDWORD HKLM "${REG_UNINSTALL}" "VersionBuild"    "${VER_BUILD}"
 
   ; Write Uninstall Information
   WriteRegStr HKLM "${REG_UNINSTALL}" InstallPath        $INSTDIR